summarylogtreecommitdiffstats
diff options
context:
space:
mode:
authorBruno Pagani2022-08-03 16:14:12 +0000
committerBruno Pagani2022-08-03 16:14:12 +0000
commitfa0afdc38fecc5ce254f2385ac1a2ae8c04729cc (patch)
tree73730f0797898f085a977ac2d30a9a27680a466b
downloadaur-fa0afdc38fecc5ce254f2385ac1a2ae8c04729cc.tar.gz
Versionned electron 19.x package
-rw-r--r--PKGBUILD302
-rw-r--r--chromium-libxml-unbundle.patch10
-rw-r--r--default_app-icon.patch21
-rw-r--r--electron-launcher.sh20
-rw-r--r--electron.desktop7
-rw-r--r--iwyu-add-utility-for-std-exchange.patch27
-rw-r--r--jinja-python-3.10.patch22
-rw-r--r--remove-no-opaque-pointers-flag.patch18
-rw-r--r--roll-src-third_party-ffmpeg.patch333
-rw-r--r--sql-make-VirtualCursor-standard-layout-type.patch238
-rw-r--r--std-vector-non-const.patch109
-rw-r--r--use-system-libraries-in-node.patch53
12 files changed, 1160 insertions, 0 deletions
diff --git a/PKGBUILD b/PKGBUILD
new file mode 100644
index 000000000000..390546415a52
--- /dev/null
+++ b/PKGBUILD
@@ -0,0 +1,302 @@
+# Maintainer: Nicola Squartini <tensor5@gmail.com>
+
+_use_suffix=1
+pkgver=19.0.10
+_commit=7e1099a8e4b04709e3d5068403c77eb0feb7371f
+_chromiumver=102.0.5005.167
+_gcc_patchset=6
+# shellcheck disable=SC2034
+pkgrel=1
+
+_major_ver=${pkgver%%.*}
+if [[ ${_use_suffix} != 0 ]]; then
+ pkgname="electron${_major_ver}"
+else
+ pkgname=electron
+fi
+# shellcheck disable=SC2034
+pkgdesc='Build cross platform desktop apps with web technologies'
+# shellcheck disable=SC2034
+arch=('x86_64')
+# shellcheck disable=SC2034
+url='https://electronjs.org/'
+# shellcheck disable=SC2034
+license=('MIT' 'custom')
+# shellcheck disable=SC2034
+depends=('c-ares' 'ffmpeg' 'gtk3' 'libevent' 'libxslt' 'minizip' 'nss' 're2'
+ 'snappy')
+# shellcheck disable=SC2034
+makedepends=('clang' 'git' 'gn' 'gperf' 'harfbuzz-icu' 'http-parser'
+ 'java-runtime-headless' 'jsoncpp' 'libnotify' 'lld' 'llvm' 'ninja'
+ 'npm' 'pciutils' 'pipewire' 'python' 'python-httplib2'
+ 'python-pyparsing' 'python-six' 'wget' 'yarn')
+# shellcheck disable=SC2034
+optdepends=('kde-cli-tools: file deletion support (kioclient5)'
+ 'libappindicator-gtk3: StatusNotifierItem support'
+ 'pipewire: WebRTC desktop sharing under Wayland'
+ 'trash-cli: file deletion support (trash-put)'
+ 'xdg-utils: open URLs with desktop’s default (xdg-email, xdg-open)')
+if [[ ${_use_suffix} == 0 ]]; then
+ # shellcheck disable=SC2034
+ conflicts=("electron${_major_ver}")
+ # shellcheck disable=SC2034
+ provides=("electron${_major_ver}")
+fi
+# shellcheck disable=SC2034
+options=('!lto') # Electron adds its own flags for ThinLTO
+# shellcheck disable=SC2034
+source=('git+https://github.com/electron/electron.git'
+ 'git+https://chromium.googlesource.com/chromium/tools/depot_tools.git#branch=main'
+ "https://github.com/stha09/chromium-patches/releases/download/chromium-${_chromiumver%%.*}-patchset-${_gcc_patchset}/chromium-${_chromiumver%%.*}-patchset-${_gcc_patchset}.tar.xz"
+ "electron-launcher.sh"
+ "electron.desktop"
+ 'default_app-icon.patch'
+ 'jinja-python-3.10.patch'
+ 'use-system-libraries-in-node.patch'
+ 'std-vector-non-const.patch'
+ 'roll-src-third_party-ffmpeg.patch'
+ 'chromium-libxml-unbundle.patch'
+ 'sql-make-VirtualCursor-standard-layout-type.patch'
+ 'remove-no-opaque-pointers-flag.patch'
+ )
+# shellcheck disable=SC2034
+sha256sums=('SKIP'
+ 'SKIP'
+ '23f2a772c4a6e31394d6ee7b8dbb5967d3b92bd859093444913377934bede594'
+ '3953f532a3ea5fce19ee33600c6ead89dcd066df6a01d3c3ab4c24f96e46fca2'
+ '4484200d90b76830b69eea3a471c103999a3ce86bb2c29e6c14c945bf4102bae'
+ 'dd2d248831dd4944d385ebf008426e66efe61d6fdf66f8932c963a12167947b4'
+ '55dbe71dbc1f3ab60bf1fa79f7aea7ef1fe76436b1d7df48728a1f8227d2134e'
+ 'c70652a8b24c237bcfd27469de32797a2cb46d9f0d63d897bb6418314a25644c'
+ '76b969e1534e8c355b8b524a686cbf3b24136eaa6bd40b0c09fdd9866049f159'
+ '30df59a9e2d95dcb720357ec4a83d9be51e59cc5551365da4c0073e68ccdec44'
+ 'fd3bf124aacc45f2d0a4f1dd86303fa7f2a3d4f4eeaf33854631d6cb39e12485'
+ 'b94b2e88f63cfb7087486508b8139599c89f96d7a4181c61fec4b4e250ca327a'
+ 'e8ea8528ecb119de3380555c60ac8495ebdef502359fa2114c6c5c98f84698cd')
+
+_system_libs=('ffmpeg'
+ 'flac'
+ 'fontconfig'
+ 'freetype'
+ 'harfbuzz-ng'
+ 'icu'
+ 'libdrm'
+ 'libevent'
+ 'libjpeg'
+ 'libpng'
+# 'libvpx'
+ 'libwebp'
+ 'libxml'
+ 'libxslt'
+# 'openh264'
+ 'opus'
+ 're2'
+ 'snappy'
+ 'zlib'
+ )
+
+prepare() {
+ sed -i "s|@ELECTRON@|${pkgname}|" electron-launcher.sh
+ sed -i "s|@ELECTRON@|${pkgname}|" electron.desktop
+ if [[ ${_use_suffix} != 0 ]]; then
+ sed -i "s|@ELECTRON_NAME@|Electron ${_major_ver}|" electron.desktop
+ else
+ sed -i "s|@ELECTRON_NAME@|Electron|" electron.desktop
+ fi
+
+ export PATH="${PATH}:${srcdir:?}/depot_tools"
+
+ echo "Fetching chromium..."
+ git clone --branch=${_chromiumver} --depth=1 \
+ https://chromium.googlesource.com/chromium/src.git
+
+ echo "solutions = [
+ {
+ \"name\": \"src/electron\",
+ \"url\": \"file://${srcdir}/electron@${_commit}\",
+ \"deps_file\": \"DEPS\",
+ \"managed\": False,
+ \"custom_deps\": {
+ \"src\": None,
+ },
+ \"custom_vars\": {},
+ },
+]" > .gclient
+
+ python "${srcdir}/depot_tools/gclient.py" sync \
+ --with_branch_heads \
+ --with_tags \
+ --nohooks
+
+ (
+ cd src/electron || exit
+ patch -Np1 -i ../../std-vector-non-const.patch
+ )
+
+ echo "Running hooks..."
+ # python "${srcdir}/depot_tools/gclient.py" runhooks
+ src/build/landmines.py
+ src/build/util/lastchange.py -o src/build/util/LASTCHANGE
+ src/build/util/lastchange.py -m GPU_LISTS_VERSION \
+ --revision-id-only --header src/gpu/config/gpu_lists_version.h
+ src/build/util/lastchange.py -m SKIA_COMMIT_HASH \
+ -s src/third_party/skia --header src/skia/ext/skia_commit_hash.h
+ # Create sysmlink to system clang-format
+ ln -s /usr/bin/clang-format src/buildtools/linux64
+ # Create sysmlink to system Node.js
+ mkdir -p src/third_party/node/linux/node-linux-x64/bin
+ ln -sf /usr/bin/node src/third_party/node/linux/node-linux-x64/bin
+ src/third_party/depot_tools/download_from_google_storage.py \
+ --no_resume --extract --no_auth --bucket chromium-nodejs \
+ -s src/third_party/node/node_modules.tar.gz.sha1
+ python src/tools/download_optimization_profile.py \
+ --newest_state=src/chrome/android/profiles/newest.txt \
+ --local_state=src/chrome/android/profiles/local.txt \
+ --output_name=src/chrome/android/profiles/afdo.prof \
+ --gs_url_base=chromeos-prebuilt/afdo-job/llvm
+ #vpython src/tools/update_pgo_profiles.py \
+ # --target=linux \
+ # update \
+ # --gs-url-base=chromium-optimization-profiles/pgo_profiles
+ src/electron/script/apply_all_patches.py \
+ src/electron/patches/config.json
+ cd src/electron || exit
+ yarn install --frozen-lockfile
+ cd ..
+
+ echo "Applying local patches..."
+ # Remove '-Xclang -no-opaque-pointers' flag not supported by our clang
+ patch -Np1 -i ../remove-no-opaque-pointers-flag.patch
+
+ # Revert ffmpeg roll requiring new channel layout API support
+ # https://crbug.com/1325301
+ patch -Rp1 -i ../roll-src-third_party-ffmpeg.patch
+
+ # https://chromium-review.googlesource.com/c/chromium/src/+/3488058
+ patch -Np1 -i ../chromium-libxml-unbundle.patch
+
+ # https://chromium-review.googlesource.com/c/chromium/src/+/2862724
+ patch -Np1 -i ../sql-make-VirtualCursor-standard-layout-type.patch
+
+ # Fixes for building with libstdc++ instead of libc++
+ patch -Np1 -i ../patches/chromium-102-fenced_frame_utils-include.patch
+ patch -Np1 -i ../patches/chromium-102-regex_pattern-array.patch
+ patch -Np1 -i ../patches/chromium-102-swiftshader-template-instantiation.patch
+ patch -Np1 -i ../patches/chromium-102-symbolize-include.patch
+
+ # Electron specific fixes
+ patch -d third_party/electron_node/tools/inspector_protocol/jinja2 \
+ -Np1 -i ../../../../../../jinja-python-3.10.patch
+ patch -Np1 -i ../use-system-libraries-in-node.patch
+ patch -Np1 -i ../default_app-icon.patch # Icon from .desktop file
+
+ echo "Patching Chromium for using system libraries..."
+ sed -i 's/OFFICIAL_BUILD/GOOGLE_CHROME_BUILD/' \
+ tools/generate_shim_headers/generate_shim_headers.py
+ for lib in $(printf "%s\n" "${_system_libs[@]}" | sed 's/^libjpeg$/&_turbo/'); do
+ third_party_dir="third_party/${lib}"
+ if [ ! -d "${third_party_dir}" ]; then
+ third_party_dir="base/${third_party_dir}"
+ fi
+ find "${third_party_dir}" -type f \
+ \! -path "${third_party_dir}/chromium/*" \
+ \! -path "${third_party_dir}/google/*" \
+ \! -path 'third_party/harfbuzz-ng/utils/hb_scoped.h' \
+ \! -regex '.*\.\(gn\|gni\|isolate\)' \
+ -delete
+ done
+ build/linux/unbundle/replace_gn_files.py \
+ --system-libraries \
+ "${_system_libs[@]}"
+}
+
+build() {
+ export CC=clang
+ export CXX=clang++
+ export AR=ar
+ export NM=nm
+
+ # Facilitate deterministic builds (taken from build/config/compiler/BUILD.gn)
+ CFLAGS+=' -Wno-builtin-macro-redefined'
+ CXXFLAGS+=' -Wno-builtin-macro-redefined'
+ CPPFLAGS+=' -D__DATE__= -D__TIME__= -D__TIMESTAMP__='
+
+ # Do not warn about unknown warning options
+ CFLAGS+=' -Wno-unknown-warning-option'
+ CXXFLAGS+=' -Wno-unknown-warning-option'
+
+ # Let Chromium set its own symbol level
+ CFLAGS=${CFLAGS/-g }
+ CXXFLAGS=${CXXFLAGS/-g }
+
+ # https://github.com/ungoogled-software/ungoogled-chromium-archlinux/issues/123
+ CFLAGS=${CFLAGS/-fexceptions}
+ CFLAGS=${CFLAGS/-fcf-protection}
+ CXXFLAGS=${CXXFLAGS/-fexceptions}
+ CXXFLAGS=${CXXFLAGS/-fcf-protection}
+
+ # This appears to cause random segfaults when combined with ThinLTO
+ # https://bugs.archlinux.org/task/73518
+ CFLAGS=${CFLAGS/-fstack-clash-protection}
+ CXXFLAGS=${CXXFLAGS/-fstack-clash-protection}
+
+ # https://crbug.com/957519#c122
+ CXXFLAGS=${CXXFLAGS/-Wp,-D_GLIBCXX_ASSERTIONS}
+
+ # Do not warn about unknown warning options
+ CFLAGS+=' -Wno-unknown-warning-option'
+ CXXFLAGS+=' -Wno-unknown-warning-option'
+
+ cd src || exit
+ export CHROMIUM_BUILDTOOLS_PATH="${PWD}/buildtools"
+ GN_EXTRA_ARGS='
+ custom_toolchain = "//build/toolchain/linux/unbundle:default"
+ host_toolchain = "//build/toolchain/linux/unbundle:default"
+ clang_use_chrome_plugins = false
+ symbol_level = 0
+ chrome_pgo_phase = 0
+ treat_warnings_as_errors = false
+ rtc_use_pipewire = true
+ link_pulseaudio = true
+ use_gnome_keyring = false
+ use_sysroot = false
+ use_custom_libcxx = false
+ icu_use_data_file = false
+ is_component_ffmpeg = false
+ '
+ gn gen out/Release \
+ --args="import(\"//electron/build/args/release.gn\") ${GN_EXTRA_ARGS}"
+ ninja -C out/Release electron
+ # Strip before zip to avoid
+ # zipfile.LargeZipFile: Filesize would require ZIP64 extensions
+ strip -s out/Release/electron
+ ninja -C out/Release electron_dist_zip
+ # ninja -C out/Release third_party/electron_node:headers
+}
+
+package() {
+ install -dm755 "${pkgdir:?}/usr/lib/${pkgname}"
+ bsdtar -xf src/out/Release/dist.zip -C "${pkgdir}/usr/lib/${pkgname}"
+
+ chmod u+s "${pkgdir}/usr/lib/${pkgname}/chrome-sandbox"
+
+ install -dm755 "${pkgdir}/usr/share/licenses/${pkgname}"
+ for l in "${pkgdir}/usr/lib/${pkgname}"/{LICENSE,LICENSES.chromium.html}; do
+ ln -s \
+ "$(realpath --relative-to="${pkgdir}/usr/share/licenses/${pkgname}" "${l}")" \
+ "${pkgdir}/usr/share/licenses/${pkgname}"
+ done
+
+ install -Dm755 "${srcdir}/electron-launcher.sh" \
+ "${pkgdir}/usr/bin/${pkgname}"
+ if [[ "${_use_suffix}" == 0 ]]; then
+ ln -s "/usr/bin/${pkgname}" "${pkgdir}/usr/bin/${pkgname}${_major_ver}"
+ ln -s "/usr/lib/${pkgname}" "${pkgdir}/usr/lib/${pkgname}${_major_ver}"
+ fi
+
+ # Install .desktop and icon file (see default_app-icon.patch)
+ install -Dm644 electron.desktop \
+ "${pkgdir}/usr/share/applications/${pkgname}.desktop"
+ install -Dm644 src/electron/default_app/icon.png \
+ "${pkgdir}/usr/share/pixmaps/${pkgname}.png" # hicolor has no 1024x1024
+}
diff --git a/chromium-libxml-unbundle.patch b/chromium-libxml-unbundle.patch
new file mode 100644
index 000000000000..5699bc8f8eaf
--- /dev/null
+++ b/chromium-libxml-unbundle.patch
@@ -0,0 +1,10 @@
+--- a/build/linux/unbundle/libxml.gn
++++ b/build/linux/unbundle/libxml.gn
+@@ -19,6 +19,7 @@ static_library("libxml_utils") {
+ ":xml_reader",
+ ":xml_writer",
+ "//base/test:test_support",
++ "//services/data_decoder:lib",
+ "//services/data_decoder:xml_parser_fuzzer_deps",
+ ]
+ sources = [
diff --git a/default_app-icon.patch b/default_app-icon.patch
new file mode 100644
index 000000000000..b2a87707d1a2
--- /dev/null
+++ b/default_app-icon.patch
@@ -0,0 +1,21 @@
+--- a/electron/default_app/default_app.ts
++++ b/electron/default_app/default_app.ts
+@@ -60,7 +60,7 @@
+ };
+
+ if (process.platform === 'linux') {
+- options.icon = path.join(__dirname, 'icon.png');
++ options.icon = '/usr/share/pixmaps/electron.png';
+ }
+
+ mainWindow = new BrowserWindow(options);
+--- a/electron/filenames.gni
++++ b/electron/filenames.gni
+@@ -6,7 +6,6 @@
+ ]
+
+ default_app_static_sources = [
+- "default_app/icon.png",
+ "default_app/index.html",
+ "default_app/package.json",
+ "default_app/styles.css",
diff --git a/electron-launcher.sh b/electron-launcher.sh
new file mode 100644
index 000000000000..e88423fa33fd
--- /dev/null
+++ b/electron-launcher.sh
@@ -0,0 +1,20 @@
+#!/usr/bin/bash
+
+set -euo pipefail
+
+name=@ELECTRON@
+flags_file="${XDG_CONFIG_HOME:-$HOME/.config}/${name}-flags.conf"
+
+declare -a flags
+
+if [[ -f "${flags_file}" ]]; then
+ mapfile -t < "${flags_file}"
+fi
+
+for line in "${MAPFILE[@]}"; do
+ if [[ ! "${line}" =~ ^[[:space:]]*#.* ]]; then
+ flags+=("${line}")
+ fi
+done
+
+exec /usr/lib/${name}/electron "$@" "${flags[@]}"
diff --git a/electron.desktop b/electron.desktop
new file mode 100644
index 000000000000..700a4d9b0be6
--- /dev/null
+++ b/electron.desktop
@@ -0,0 +1,7 @@
+[Desktop Entry]
+Type=Application
+Name=@ELECTRON_NAME@
+Icon=@ELECTRON@
+Exec=@ELECTRON@ %u
+Categories=Development;GTK;
+StartupNotify=true
diff --git a/iwyu-add-utility-for-std-exchange.patch b/iwyu-add-utility-for-std-exchange.patch
new file mode 100644
index 000000000000..3bc4693e19fb
--- /dev/null
+++ b/iwyu-add-utility-for-std-exchange.patch
@@ -0,0 +1,27 @@
+From 9dd0503835dc875807ab63efb1f477bffed2a852 Mon Sep 17 00:00:00 2001
+From: Stephan Hartmann <stha09@googlemail.com>
+Date: Mon, 25 Apr 2022 23:18:30 +0000
+Subject: [PATCH] IWYU: add utility for std::exchange
+
+Bug: 957519
+Change-Id: I307d520fdc34d2452018ed32a505e7e519739410
+Reviewed-on: https://chromium-review.googlesource.com/c/chromium/src/+/3604643
+Reviewed-by: Wez <wez@chromium.org>
+Commit-Queue: Stephan Hartmann <stha09@googlemail.com>
+Cr-Commit-Position: refs/heads/main@{#995855}
+---
+ base/third_party/symbolize/symbolize.h | 1 +
+ 1 file changed, 1 insertion(+)
+
+diff --git a/base/third_party/symbolize/symbolize.h b/base/third_party/symbolize/symbolize.h
+index 99029a968d5..278078f6071 100644
+--- a/base/third_party/symbolize/symbolize.h
++++ b/base/third_party/symbolize/symbolize.h
+@@ -61,6 +61,7 @@
+ #ifdef HAVE_SYMBOLIZE
+
+ #include <algorithm>
++#include <utility>
+
+ #if defined(__ELF__) // defined by gcc
+ #if defined(__OpenBSD__)
diff --git a/jinja-python-3.10.patch b/jinja-python-3.10.patch
new file mode 100644
index 000000000000..647fe5bbb39f
--- /dev/null
+++ b/jinja-python-3.10.patch
@@ -0,0 +1,22 @@
+--- a/runtime.py
++++ b/runtime.py
+@@ -315,7 +315,7 @@ class Context(with_metaclass(ContextMeta
+
+ # register the context as mapping if possible
+ try:
+- from collections import Mapping
++ from collections.abc import Mapping
+ Mapping.register(Context)
+ except ImportError:
+ pass
+--- a/sandbox.py
++++ b/sandbox.py
+@@ -14,7 +14,7 @@
+ """
+ import types
+ import operator
+-from collections import Mapping
++from collections.abc import Mapping
+ from jinja2.environment import Environment
+ from jinja2.exceptions import SecurityError
+ from jinja2._compat import string_types, PY2
diff --git a/remove-no-opaque-pointers-flag.patch b/remove-no-opaque-pointers-flag.patch
new file mode 100644
index 000000000000..474028ebc68d
--- /dev/null
+++ b/remove-no-opaque-pointers-flag.patch
@@ -0,0 +1,18 @@
+--- a/build/config/compiler/BUILD.gn 2022-05-19 10:35:52.991415777 +0000
++++ b/build/config/compiler/BUILD.gn 2022-05-19 10:36:11.102017131 +0000
+@@ -1538,15 +1538,6 @@ config("default_warnings") {
+ cflags += [ "-Wno-deprecated-non-prototype" ]
+ }
+
+- if (!is_nacl && !(is_chromeos ||
+- default_toolchain == "//build/toolchain/cros:target")) {
+- # TODO(https://crbug.com/1316298): Re-enable once test failure is figured out
+- cflags += [
+- "-Xclang",
+- "-no-opaque-pointers",
+- ]
+- }
+-
+ if (is_fuchsia) {
+ # TODO(https://bugs.chromium.org/p/fuchsia/issues/detail?id=77383)
+ cflags += [ "-Wno-deprecated-copy" ]
diff --git a/roll-src-third_party-ffmpeg.patch b/roll-src-third_party-ffmpeg.patch
new file mode 100644
index 000000000000..e739b40a2733
--- /dev/null
+++ b/roll-src-third_party-ffmpeg.patch
@@ -0,0 +1,333 @@
+From 6e554a30893150793c2638e3689cf208ffc8e375 Mon Sep 17 00:00:00 2001
+From: Dale Curtis <dalecurtis@chromium.org>
+Date: Sat, 2 Apr 2022 05:13:53 +0000
+Subject: [PATCH] Roll src/third_party/ffmpeg/ 574c39cce..32b2d1d526 (1125
+ commits)
+
+https://chromium.googlesource.com/chromium/third_party/ffmpeg.git/+log/574c39cce323..32b2d1d526
+
+Created with:
+ roll-dep src/third_party/ffmpeg
+
+Fixed: 1293918
+Cq-Include-Trybots: luci.chromium.try:mac_chromium_asan_rel_ng,linux_chromium_asan_rel_ng,linux_chromium_chromeos_asan_rel_ng
+Change-Id: I41945d0f963e3d1f65940067bac22f63b68e37d2
+Reviewed-on: https://chromium-review.googlesource.com/c/chromium/src/+/3565647
+Auto-Submit: Dale Curtis <dalecurtis@chromium.org>
+Reviewed-by: Dan Sanders <sandersd@chromium.org>
+Commit-Queue: Dale Curtis <dalecurtis@chromium.org>
+Cr-Commit-Position: refs/heads/main@{#988253}
+---
+ .../clear_key_cdm/ffmpeg_cdm_audio_decoder.cc | 29 ++++++++++---------
+ media/ffmpeg/ffmpeg_common.cc | 11 +++----
+ media/filters/audio_file_reader.cc | 9 +++---
+ media/filters/audio_file_reader_unittest.cc | 6 ++--
+ .../filters/audio_video_metadata_extractor.cc | 11 +++++--
+ .../filters/ffmpeg_aac_bitstream_converter.cc | 7 +++--
+ ...ffmpeg_aac_bitstream_converter_unittest.cc | 2 +-
+ media/filters/ffmpeg_audio_decoder.cc | 13 +++++----
+ 8 files changed, 51 insertions(+), 37 deletions(-)
+
+diff --git a/media/cdm/library_cdm/clear_key_cdm/ffmpeg_cdm_audio_decoder.cc b/media/cdm/library_cdm/clear_key_cdm/ffmpeg_cdm_audio_decoder.cc
+index e4fc3f460e2..9b1ad9f7675 100644
+--- a/media/cdm/library_cdm/clear_key_cdm/ffmpeg_cdm_audio_decoder.cc
++++ b/media/cdm/library_cdm/clear_key_cdm/ffmpeg_cdm_audio_decoder.cc
+@@ -74,7 +74,7 @@ void CdmAudioDecoderConfigToAVCodecContext(
+ codec_context->sample_fmt = AV_SAMPLE_FMT_NONE;
+ }
+
+- codec_context->channels = config.channel_count;
++ codec_context->ch_layout.nb_channels = config.channel_count;
+ codec_context->sample_rate = config.samples_per_second;
+
+ if (config.extra_data) {
+@@ -124,8 +124,8 @@ void CopySamples(cdm::AudioFormat cdm_format,
+ case cdm::kAudioFormatPlanarS16:
+ case cdm::kAudioFormatPlanarF32: {
+ const int decoded_size_per_channel =
+- decoded_audio_size / av_frame.channels;
+- for (int i = 0; i < av_frame.channels; ++i) {
++ decoded_audio_size / av_frame.ch_layout.nb_channels;
++ for (int i = 0; i < av_frame.ch_layout.nb_channels; ++i) {
+ memcpy(output_buffer, av_frame.extended_data[i],
+ decoded_size_per_channel);
+ output_buffer += decoded_size_per_channel;
+@@ -185,13 +185,14 @@ bool FFmpegCdmAudioDecoder::Initialize(
+ // Success!
+ decoding_loop_ = std::make_unique<FFmpegDecodingLoop>(codec_context_.get());
+ samples_per_second_ = config.samples_per_second;
+- bytes_per_frame_ = codec_context_->channels * config.bits_per_channel / 8;
++ bytes_per_frame_ =
++ codec_context_->ch_layout.nb_channels * config.bits_per_channel / 8;
+ output_timestamp_helper_ =
+ std::make_unique<AudioTimestampHelper>(config.samples_per_second);
+ is_initialized_ = true;
+
+ // Store initial values to guard against midstream configuration changes.
+- channels_ = codec_context_->channels;
++ channels_ = codec_context_->ch_layout.nb_channels;
+ av_sample_format_ = codec_context_->sample_fmt;
+
+ return true;
+@@ -291,17 +292,19 @@ cdm::Status FFmpegCdmAudioDecoder::DecodeBuffer(
+ for (auto& frame : audio_frames) {
+ int decoded_audio_size = 0;
+ if (frame->sample_rate != samples_per_second_ ||
+- frame->channels != channels_ || frame->format != av_sample_format_) {
++ frame->ch_layout.nb_channels != channels_ ||
++ frame->format != av_sample_format_) {
+ DLOG(ERROR) << "Unsupported midstream configuration change!"
+ << " Sample Rate: " << frame->sample_rate << " vs "
+- << samples_per_second_ << ", Channels: " << frame->channels
+- << " vs " << channels_ << ", Sample Format: " << frame->format
+- << " vs " << av_sample_format_;
++ << samples_per_second_
++ << ", Channels: " << frame->ch_layout.nb_channels << " vs "
++ << channels_ << ", Sample Format: " << frame->format << " vs "
++ << av_sample_format_;
+ return cdm::kDecodeError;
+ }
+
+ decoded_audio_size = av_samples_get_buffer_size(
+- nullptr, codec_context_->channels, frame->nb_samples,
++ nullptr, codec_context_->ch_layout.nb_channels, frame->nb_samples,
+ codec_context_->sample_fmt, 1);
+ if (!decoded_audio_size)
+ continue;
+@@ -320,9 +323,9 @@ bool FFmpegCdmAudioDecoder::OnNewFrame(
+ size_t* total_size,
+ std::vector<std::unique_ptr<AVFrame, ScopedPtrAVFreeFrame>>* audio_frames,
+ AVFrame* frame) {
+- *total_size += av_samples_get_buffer_size(nullptr, codec_context_->channels,
+- frame->nb_samples,
+- codec_context_->sample_fmt, 1);
++ *total_size += av_samples_get_buffer_size(
++ nullptr, codec_context_->ch_layout.nb_channels, frame->nb_samples,
++ codec_context_->sample_fmt, 1);
+ audio_frames->emplace_back(av_frame_clone(frame));
+ return true;
+ }
+diff --git a/media/ffmpeg/ffmpeg_common.cc b/media/ffmpeg/ffmpeg_common.cc
+index 87ca8969626..76f03d6608e 100644
+--- a/media/ffmpeg/ffmpeg_common.cc
++++ b/media/ffmpeg/ffmpeg_common.cc
+@@ -345,10 +345,11 @@ bool AVCodecContextToAudioDecoderConfig(const AVCodecContext* codec_context,
+ codec_context->sample_fmt, codec_context->codec_id);
+
+ ChannelLayout channel_layout =
+- codec_context->channels > 8
++ codec_context->ch_layout.nb_channels > 8
+ ? CHANNEL_LAYOUT_DISCRETE
+- : ChannelLayoutToChromeChannelLayout(codec_context->channel_layout,
+- codec_context->channels);
++ : ChannelLayoutToChromeChannelLayout(
++ codec_context->ch_layout.u.mask,
++ codec_context->ch_layout.nb_channels);
+
+ int sample_rate = codec_context->sample_rate;
+ switch (codec) {
+@@ -401,7 +402,7 @@ bool AVCodecContextToAudioDecoderConfig(const AVCodecContext* codec_context,
+ extra_data, encryption_scheme, seek_preroll,
+ codec_context->delay);
+ if (channel_layout == CHANNEL_LAYOUT_DISCRETE)
+- config->SetChannelsForDiscrete(codec_context->channels);
++ config->SetChannelsForDiscrete(codec_context->ch_layout.nb_channels);
+
+ #if BUILDFLAG(ENABLE_PLATFORM_AC3_EAC3_AUDIO)
+ // These are bitstream formats unknown to ffmpeg, so they don't have
+@@ -470,7 +471,7 @@ void AudioDecoderConfigToAVCodecContext(const AudioDecoderConfig& config,
+
+ // TODO(scherkus): should we set |channel_layout|? I'm not sure if FFmpeg uses
+ // said information to decode.
+- codec_context->channels = config.channels();
++ codec_context->ch_layout.nb_channels = config.channels();
+ codec_context->sample_rate = config.samples_per_second();
+
+ if (config.extra_data().empty()) {
+diff --git a/media/filters/audio_file_reader.cc b/media/filters/audio_file_reader.cc
+index 5f257bdfaa6..e1be5aa9a5b 100644
+--- a/media/filters/audio_file_reader.cc
++++ b/media/filters/audio_file_reader.cc
+@@ -113,14 +113,15 @@ bool AudioFileReader::OpenDecoder() {
+
+ // Verify the channel layout is supported by Chrome. Acts as a sanity check
+ // against invalid files. See http://crbug.com/171962
+- if (ChannelLayoutToChromeChannelLayout(codec_context_->channel_layout,
+- codec_context_->channels) ==
++ if (ChannelLayoutToChromeChannelLayout(
++ codec_context_->ch_layout.u.mask,
++ codec_context_->ch_layout.nb_channels) ==
+ CHANNEL_LAYOUT_UNSUPPORTED) {
+ return false;
+ }
+
+ // Store initial values to guard against midstream configuration changes.
+- channels_ = codec_context_->channels;
++ channels_ = codec_context_->ch_layout.nb_channels;
+ audio_codec_ = CodecIDToAudioCodec(codec_context_->codec_id);
+ sample_rate_ = codec_context_->sample_rate;
+ av_sample_format_ = codec_context_->sample_fmt;
+@@ -223,7 +224,7 @@ bool AudioFileReader::OnNewFrame(
+ if (frames_read < 0)
+ return false;
+
+- const int channels = frame->channels;
++ const int channels = frame->ch_layout.nb_channels;
+ if (frame->sample_rate != sample_rate_ || channels != channels_ ||
+ frame->format != av_sample_format_) {
+ DLOG(ERROR) << "Unsupported midstream configuration change!"
+diff --git a/media/filters/audio_file_reader_unittest.cc b/media/filters/audio_file_reader_unittest.cc
+index 2aba7927a31..1f45a50cace 100644
+--- a/media/filters/audio_file_reader_unittest.cc
++++ b/media/filters/audio_file_reader_unittest.cc
+@@ -121,11 +121,11 @@ class AudioFileReaderTest : public testing::Test {
+ EXPECT_FALSE(reader_->Open());
+ }
+
+- void RunTestFailingDecode(const char* fn) {
++ void RunTestFailingDecode(const char* fn, int expect_read = 0) {
+ Initialize(fn);
+ EXPECT_TRUE(reader_->Open());
+ std::vector<std::unique_ptr<AudioBus>> decoded_audio_packets;
+- EXPECT_EQ(reader_->Read(&decoded_audio_packets), 0);
++ EXPECT_EQ(reader_->Read(&decoded_audio_packets), expect_read);
+ }
+
+ void RunTestPartialDecode(const char* fn) {
+@@ -219,7 +219,7 @@ TEST_F(AudioFileReaderTest, AAC_ADTS) {
+ }
+
+ TEST_F(AudioFileReaderTest, MidStreamConfigChangesFail) {
+- RunTestFailingDecode("midstream_config_change.mp3");
++ RunTestFailingDecode("midstream_config_change.mp3", 42624);
+ }
+ #endif
+
+diff --git a/media/filters/audio_video_metadata_extractor.cc b/media/filters/audio_video_metadata_extractor.cc
+index 185819eb936..69ff508c221 100644
+--- a/media/filters/audio_video_metadata_extractor.cc
++++ b/media/filters/audio_video_metadata_extractor.cc
+@@ -113,6 +113,15 @@ bool AudioVideoMetadataExtractor::Extract(DataSource* source,
+ if (!stream)
+ continue;
+
++ void* display_matrix =
++ av_stream_get_side_data(stream, AV_PKT_DATA_DISPLAYMATRIX, nullptr);
++ if (display_matrix) {
++ rotation_ = VideoTransformation::FromFFmpegDisplayMatrix(
++ static_cast<int32_t*>(display_matrix))
++ .rotation;
++ info.tags["rotate"] = base::NumberToString(rotation_);
++ }
++
+ // Extract dictionary from streams also. Needed for containers that attach
+ // metadata to contained streams instead the container itself, like OGG.
+ ExtractDictionary(stream->metadata, &info.tags);
+@@ -255,8 +264,6 @@ void AudioVideoMetadataExtractor::ExtractDictionary(AVDictionary* metadata,
+ if (raw_tags->find(tag->key) == raw_tags->end())
+ (*raw_tags)[tag->key] = tag->value;
+
+- if (ExtractInt(tag, "rotate", &rotation_))
+- continue;
+ if (ExtractString(tag, "album", &album_))
+ continue;
+ if (ExtractString(tag, "artist", &artist_))
+diff --git a/media/filters/ffmpeg_aac_bitstream_converter.cc b/media/filters/ffmpeg_aac_bitstream_converter.cc
+index 6f231c85729..ca5e5fb927d 100644
+--- a/media/filters/ffmpeg_aac_bitstream_converter.cc
++++ b/media/filters/ffmpeg_aac_bitstream_converter.cc
+@@ -195,14 +195,15 @@ bool FFmpegAACBitstreamConverter::ConvertPacket(AVPacket* packet) {
+ if (!header_generated_ || codec_ != stream_codec_parameters_->codec_id ||
+ audio_profile_ != stream_codec_parameters_->profile ||
+ sample_rate_index_ != sample_rate_index ||
+- channel_configuration_ != stream_codec_parameters_->channels ||
++ channel_configuration_ !=
++ stream_codec_parameters_->ch_layout.nb_channels ||
+ frame_length_ != header_plus_packet_size) {
+ header_generated_ =
+ GenerateAdtsHeader(stream_codec_parameters_->codec_id,
+ 0, // layer
+ stream_codec_parameters_->profile, sample_rate_index,
+ 0, // private stream
+- stream_codec_parameters_->channels,
++ stream_codec_parameters_->ch_layout.nb_channels,
+ 0, // originality
+ 0, // home
+ 0, // copyrighted_stream
+@@ -214,7 +215,7 @@ bool FFmpegAACBitstreamConverter::ConvertPacket(AVPacket* packet) {
+ codec_ = stream_codec_parameters_->codec_id;
+ audio_profile_ = stream_codec_parameters_->profile;
+ sample_rate_index_ = sample_rate_index;
+- channel_configuration_ = stream_codec_parameters_->channels;
++ channel_configuration_ = stream_codec_parameters_->ch_layout.nb_channels;
+ frame_length_ = header_plus_packet_size;
+ }
+
+diff --git a/media/filters/ffmpeg_aac_bitstream_converter_unittest.cc b/media/filters/ffmpeg_aac_bitstream_converter_unittest.cc
+index 1fd4c5ccd7d..f59bcd8fdaf 100644
+--- a/media/filters/ffmpeg_aac_bitstream_converter_unittest.cc
++++ b/media/filters/ffmpeg_aac_bitstream_converter_unittest.cc
+@@ -34,7 +34,7 @@ class FFmpegAACBitstreamConverterTest : public testing::Test {
+ memset(&test_parameters_, 0, sizeof(AVCodecParameters));
+ test_parameters_.codec_id = AV_CODEC_ID_AAC;
+ test_parameters_.profile = FF_PROFILE_AAC_MAIN;
+- test_parameters_.channels = 2;
++ test_parameters_.ch_layout.nb_channels = 2;
+ test_parameters_.extradata = extradata_header_;
+ test_parameters_.extradata_size = sizeof(extradata_header_);
+ }
+diff --git a/media/filters/ffmpeg_audio_decoder.cc b/media/filters/ffmpeg_audio_decoder.cc
+index 6a56c675f7d..4615fdeb3fb 100644
+--- a/media/filters/ffmpeg_audio_decoder.cc
++++ b/media/filters/ffmpeg_audio_decoder.cc
+@@ -28,7 +28,7 @@ namespace media {
+
+ // Return the number of channels from the data in |frame|.
+ static inline int DetermineChannels(AVFrame* frame) {
+- return frame->channels;
++ return frame->ch_layout.nb_channels;
+ }
+
+ // Called by FFmpeg's allocation routine to allocate a buffer. Uses
+@@ -231,7 +231,7 @@ bool FFmpegAudioDecoder::OnNewFrame(const DecoderBuffer& buffer,
+ // Translate unsupported into discrete layouts for discrete configurations;
+ // ffmpeg does not have a labeled discrete configuration internally.
+ ChannelLayout channel_layout = ChannelLayoutToChromeChannelLayout(
+- codec_context_->channel_layout, codec_context_->channels);
++ codec_context_->ch_layout.u.mask, codec_context_->ch_layout.nb_channels);
+ if (channel_layout == CHANNEL_LAYOUT_UNSUPPORTED &&
+ config_.channel_layout() == CHANNEL_LAYOUT_DISCRETE) {
+ channel_layout = CHANNEL_LAYOUT_DISCRETE;
+@@ -348,11 +348,11 @@ bool FFmpegAudioDecoder::ConfigureDecoder(const AudioDecoderConfig& config) {
+ // Success!
+ av_sample_format_ = codec_context_->sample_fmt;
+
+- if (codec_context_->channels != config.channels()) {
++ if (codec_context_->ch_layout.nb_channels != config.channels()) {
+ MEDIA_LOG(ERROR, media_log_)
+ << "Audio configuration specified " << config.channels()
+ << " channels, but FFmpeg thinks the file contains "
+- << codec_context_->channels << " channels";
++ << codec_context_->ch_layout.nb_channels << " channels";
+ ReleaseFFmpegResources();
+ state_ = DecoderState::kUninitialized;
+ return false;
+@@ -403,7 +403,7 @@ int FFmpegAudioDecoder::GetAudioBuffer(struct AVCodecContext* s,
+ if (frame->nb_samples <= 0)
+ return AVERROR(EINVAL);
+
+- if (s->channels != channels) {
++ if (s->ch_layout.nb_channels != channels) {
+ DLOG(ERROR) << "AVCodecContext and AVFrame disagree on channel count.";
+ return AVERROR(EINVAL);
+ }
+@@ -436,7 +436,8 @@ int FFmpegAudioDecoder::GetAudioBuffer(struct AVCodecContext* s,
+ ChannelLayout channel_layout =
+ config_.channel_layout() == CHANNEL_LAYOUT_DISCRETE
+ ? CHANNEL_LAYOUT_DISCRETE
+- : ChannelLayoutToChromeChannelLayout(s->channel_layout, s->channels);
++ : ChannelLayoutToChromeChannelLayout(s->ch_layout.u.mask,
++ s->ch_layout.nb_channels);
+
+ if (channel_layout == CHANNEL_LAYOUT_UNSUPPORTED) {
+ DLOG(ERROR) << "Unsupported channel layout.";
diff --git a/sql-make-VirtualCursor-standard-layout-type.patch b/sql-make-VirtualCursor-standard-layout-type.patch
new file mode 100644
index 000000000000..3364d41ee07a
--- /dev/null
+++ b/sql-make-VirtualCursor-standard-layout-type.patch
@@ -0,0 +1,238 @@
+From 144479ad7b4287bee4067f95e4218f614798a865 Mon Sep 17 00:00:00 2001
+From: Stephan Hartmann <stha09@googlemail.com>
+Date: Sun, 16 Jan 2022 19:15:26 +0000
+Subject: [PATCH] sql: make VirtualCursor standard layout type
+
+sql::recover::VirtualCursor needs to be a standard layout type, but
+has members of type std::unique_ptr. However, std::unique_ptr is not
+guaranteed to be standard layout. Compiling with clang combined with
+gcc-11 libstdc++ fails because of this.
+
+Bug: 1189788
+Change-Id: Ia6dc388cc5ef1c0f2afc75f8ca45b9f12687ca9c
+---
+ sql/recover_module/btree.cc | 18 ++++++++++++------
+ sql/recover_module/btree.h | 21 +++++++++++++++------
+ sql/recover_module/cursor.cc | 24 ++++++++++++------------
+ sql/recover_module/cursor.h | 2 +-
+ sql/recover_module/pager.cc | 5 ++---
+ sql/recover_module/pager.h | 6 +++---
+ 6 files changed, 45 insertions(+), 31 deletions(-)
+
+diff --git a/sql/recover_module/btree.cc b/sql/recover_module/btree.cc
+index cc9420e5c05..f12d8fa32a2 100644
+--- a/sql/recover_module/btree.cc
++++ b/sql/recover_module/btree.cc
+@@ -136,16 +136,22 @@ static_assert(std::is_trivially_destructible<LeafPageDecoder>::value,
+ "Move the destructor to the .cc file if it's non-trival");
+ #endif // !DCHECK_IS_ON()
+
+-LeafPageDecoder::LeafPageDecoder(DatabasePageReader* db_reader) noexcept
+- : page_id_(db_reader->page_id()),
+- db_reader_(db_reader),
+- cell_count_(ComputeCellCount(db_reader)),
+- next_read_index_(0),
+- last_record_size_(0) {
++LeafPageDecoder::LeafPageDecoder() noexcept = default;
++
++void LeafPageDecoder::Initialize(DatabasePageReader* db_reader) {
++ page_id_ = db_reader->page_id();
++ db_reader_ = db_reader;
++ cell_count_ = ComputeCellCount(db_reader);
++ next_read_index_ = 0;
++ last_record_size_ = 0;
+ DCHECK(IsOnValidPage(db_reader));
+ DCHECK(DatabasePageReader::IsValidPageId(page_id_));
+ }
+
++void LeafPageDecoder::Reset() {
++ db_reader_ = nullptr;
++}
++
+ bool LeafPageDecoder::TryAdvance() {
+ DCHECK_CALLED_ON_VALID_SEQUENCE(sequence_checker_);
+ DCHECK(CanAdvance());
+diff --git a/sql/recover_module/btree.h b/sql/recover_module/btree.h
+index eaa087a5c52..df0e0c937c0 100644
+--- a/sql/recover_module/btree.h
++++ b/sql/recover_module/btree.h
+@@ -101,9 +101,7 @@ class LeafPageDecoder {
+ public:
+ // Creates a decoder for a DatabasePageReader's last read page.
+ //
+- // |db_reader| must have been used to read an inner page of a table B-tree.
+- // |db_reader| must outlive this instance.
+- explicit LeafPageDecoder(DatabasePageReader* db_reader) noexcept;
++ LeafPageDecoder() noexcept;
+ ~LeafPageDecoder() noexcept = default;
+
+ LeafPageDecoder(const LeafPageDecoder&) = delete;
+@@ -151,6 +149,17 @@ class LeafPageDecoder {
+ // read as long as CanAdvance() returns true.
+ bool TryAdvance();
+
++ // Initialize with DatabasePageReader
++ // |db_reader| must have been used to read an inner page of a table B-tree.
++ // |db_reader| must outlive this instance.
++ void Initialize(DatabasePageReader* db_reader);
++
++ // Reset internal DatabasePageReader
++ void Reset();
++
++ // True if DatabasePageReader is valid
++ bool IsValid() { return (db_reader_ != nullptr); }
++
+ // True if the given reader may point to an inner page in a table B-tree.
+ //
+ // The last ReadPage() call on |db_reader| must have succeeded.
+@@ -164,14 +173,14 @@ class LeafPageDecoder {
+ static int ComputeCellCount(DatabasePageReader* db_reader);
+
+ // The number of the B-tree page this reader is reading.
+- const int64_t page_id_;
++ int64_t page_id_;
+ // Used to read the tree page.
+ //
+ // Raw pointer usage is acceptable because this instance's owner is expected
+ // to ensure that the DatabasePageReader outlives this.
+- DatabasePageReader* const db_reader_;
++ DatabasePageReader* db_reader_;
+ // Caches the ComputeCellCount() value for this reader's page.
+- const int cell_count_ = ComputeCellCount(db_reader_);
++ int cell_count_;
+
+ // The reader's cursor state.
+ //
+diff --git a/sql/recover_module/cursor.cc b/sql/recover_module/cursor.cc
+index 4f827edf1b4..240de4999fe 100644
+--- a/sql/recover_module/cursor.cc
++++ b/sql/recover_module/cursor.cc
+@@ -28,7 +28,7 @@ VirtualCursor::~VirtualCursor() {
+ int VirtualCursor::First() {
+ DCHECK_CALLED_ON_VALID_SEQUENCE(sequence_checker_);
+ inner_decoders_.clear();
+- leaf_decoder_ = nullptr;
++ leaf_decoder_.Reset();
+
+ AppendPageDecoder(table_->root_page_id());
+ return Next();
+@@ -38,18 +38,18 @@ int VirtualCursor::Next() {
+ DCHECK_CALLED_ON_VALID_SEQUENCE(sequence_checker_);
+ record_reader_.Reset();
+
+- while (!inner_decoders_.empty() || leaf_decoder_.get()) {
+- if (leaf_decoder_.get()) {
+- if (!leaf_decoder_->CanAdvance()) {
++ while (!inner_decoders_.empty() || leaf_decoder_.IsValid()) {
++ if (leaf_decoder_.IsValid()) {
++ if (!leaf_decoder_.CanAdvance()) {
+ // The leaf has been exhausted. Remove it from the DFS stack.
+- leaf_decoder_ = nullptr;
++ leaf_decoder_.Reset();
+ continue;
+ }
+- if (!leaf_decoder_->TryAdvance())
++ if (!leaf_decoder_.TryAdvance())
+ continue;
+
+- if (!payload_reader_.Initialize(leaf_decoder_->last_record_size(),
+- leaf_decoder_->last_record_offset())) {
++ if (!payload_reader_.Initialize(leaf_decoder_.last_record_size(),
++ leaf_decoder_.last_record_offset())) {
+ continue;
+ }
+ if (!record_reader_.Initialize())
+@@ -101,13 +101,13 @@ int VirtualCursor::ReadColumn(int column_index,
+ int64_t VirtualCursor::RowId() {
+ DCHECK_CALLED_ON_VALID_SEQUENCE(sequence_checker_);
+ DCHECK(record_reader_.IsInitialized());
+- DCHECK(leaf_decoder_.get());
+- return leaf_decoder_->last_record_rowid();
++ DCHECK(leaf_decoder_.IsValid());
++ return leaf_decoder_.last_record_rowid();
+ }
+
+ void VirtualCursor::AppendPageDecoder(int page_id) {
+ DCHECK_CALLED_ON_VALID_SEQUENCE(sequence_checker_);
+- DCHECK(leaf_decoder_.get() == nullptr)
++ DCHECK(!leaf_decoder_.IsValid())
+ << __func__
+ << " must only be called when the current path has no leaf decoder";
+
+@@ -115,7 +115,7 @@ void VirtualCursor::AppendPageDecoder(int page_id) {
+ return;
+
+ if (LeafPageDecoder::IsOnValidPage(&db_reader_)) {
+- leaf_decoder_ = std::make_unique<LeafPageDecoder>(&db_reader_);
++ leaf_decoder_.Initialize(&db_reader_);
+ return;
+ }
+
+diff --git a/sql/recover_module/cursor.h b/sql/recover_module/cursor.h
+index 845b7852648..cc4e85f83f9 100644
+--- a/sql/recover_module/cursor.h
++++ b/sql/recover_module/cursor.h
+@@ -130,7 +130,7 @@ class VirtualCursor {
+ std::vector<std::unique_ptr<InnerPageDecoder>> inner_decoders_;
+
+ // Decodes the leaf page containing records.
+- std::unique_ptr<LeafPageDecoder> leaf_decoder_;
++ LeafPageDecoder leaf_decoder_;
+
+ SEQUENCE_CHECKER(sequence_checker_);
+ };
+diff --git a/sql/recover_module/pager.cc b/sql/recover_module/pager.cc
+index 58e75de2704..69d98cef98d 100644
+--- a/sql/recover_module/pager.cc
++++ b/sql/recover_module/pager.cc
+@@ -23,8 +23,7 @@ static_assert(DatabasePageReader::kMaxPageId <= std::numeric_limits<int>::max(),
+ "ints are not appropriate for representing page IDs");
+
+ DatabasePageReader::DatabasePageReader(VirtualTable* table)
+- : page_data_(std::make_unique<uint8_t[]>(table->page_size())),
+- table_(table) {
++ : page_data_(table->page_size()), table_(table) {
+ DCHECK(table != nullptr);
+ DCHECK(IsValidPageSize(table->page_size()));
+ }
+@@ -58,7 +57,7 @@ int DatabasePageReader::ReadPage(int page_id) {
+ "The |read_offset| computation above may overflow");
+
+ int sqlite_status =
+- RawRead(sqlite_file, read_size, read_offset, page_data_.get());
++ RawRead(sqlite_file, read_size, read_offset, page_data_.data());
+
+ // |page_id_| needs to be set to kInvalidPageId if the read failed.
+ // Otherwise, future ReadPage() calls with the previous |page_id_| value
+diff --git a/sql/recover_module/pager.h b/sql/recover_module/pager.h
+index 07cac3cb989..d08f0932fab 100644
+--- a/sql/recover_module/pager.h
++++ b/sql/recover_module/pager.h
+@@ -6,8 +6,8 @@
+ #define SQL_RECOVER_MODULE_PAGER_H_
+
+ #include <cstdint>
+-#include <memory>
+ #include <ostream>
++#include <vector>
+
+ #include "base/check_op.h"
+ #include "base/memory/raw_ptr.h"
+@@ -72,7 +72,7 @@ class DatabasePageReader {
+ DCHECK_CALLED_ON_VALID_SEQUENCE(sequence_checker_);
+ DCHECK_NE(page_id_, kInvalidPageId)
+ << "Successful ReadPage() required before accessing pager state";
+- return page_data_.get();
++ return page_data_.data();
+ }
+
+ // The number of bytes in the page read by the last ReadPage() call.
+@@ -139,7 +139,7 @@ class DatabasePageReader {
+ int page_id_ = kInvalidPageId;
+ // Stores the bytes of the last page successfully read by ReadPage().
+ // The content is undefined if the last call to ReadPage() did not succeed.
+- const std::unique_ptr<uint8_t[]> page_data_;
++ std::vector<uint8_t> page_data_;
+ // Raw pointer usage is acceptable because this instance's owner is expected
+ // to ensure that the VirtualTable outlives this.
+ const raw_ptr<VirtualTable> table_;
diff --git a/std-vector-non-const.patch b/std-vector-non-const.patch
new file mode 100644
index 000000000000..89de8a1afff5
--- /dev/null
+++ b/std-vector-non-const.patch
@@ -0,0 +1,109 @@
+--- a/patches/chromium/feat_add_data_parameter_to_processsingleton.patch
++++ b/patches/chromium/feat_add_data_parameter_to_processsingleton.patch
+@@ -32,7 +32,7 @@ index 5a64220aaf1309832dc0ad543e353de67fe0a779..e75c4f0d7cf1cac2e5862eb858800359
+ - const base::FilePath& current_directory)>;
+ + base::RepeatingCallback<bool(const base::CommandLine& command_line,
+ + const base::FilePath& current_directory,
+-+ const std::vector<const uint8_t> additional_data)>;
+++ const std::vector<uint8_t> additional_data)>;
+
+ #if BUILDFLAG(IS_WIN)
+ ProcessSingleton(const std::string& program_name,
+@@ -73,7 +73,7 @@ index 7d3a441bdb64268ed5fbfa7bf589fb35a2fd1b75..a3e45e9baa09bfc87be5b7ff589ac768
+ // |reader| is for sending back ACK message.
+ void HandleMessage(const std::string& current_dir,
+ const std::vector<std::string>& argv,
+-+ const std::vector<const uint8_t> additional_data,
+++ const std::vector<uint8_t> additional_data,
+ SocketReader* reader);
+
+ private:
+@@ -84,7 +84,7 @@ index 7d3a441bdb64268ed5fbfa7bf589fb35a2fd1b75..a3e45e9baa09bfc87be5b7ff589ac768
+ - const std::string& current_dir, const std::vector<std::string>& argv,
+ + const std::string& current_dir,
+ + const std::vector<std::string>& argv,
+-+ const std::vector<const uint8_t> additional_data,
+++ const std::vector<uint8_t> additional_data,
+ SocketReader* reader) {
+ DCHECK(ui_task_runner_->BelongsToCurrentThread());
+ DCHECK(reader);
+@@ -114,7 +114,7 @@ index 7d3a441bdb64268ed5fbfa7bf589fb35a2fd1b75..a3e45e9baa09bfc87be5b7ff589ac768
+ + base::StringToSizeT(tokens[0], &num_args);
+ + std::vector<std::string> command_line(tokens.begin() + 1, tokens.begin() + 1 + num_args);
+ +
+-+ std::vector<const uint8_t> additional_data;
+++ std::vector<uint8_t> additional_data;
+ + if (tokens.size() >= 3 + num_args) {
+ + size_t additional_data_size;
+ + base::StringToSizeT(tokens[1 + num_args], &additional_data_size);
+@@ -123,7 +123,7 @@ index 7d3a441bdb64268ed5fbfa7bf589fb35a2fd1b75..a3e45e9baa09bfc87be5b7ff589ac768
+ + std::string(1, kTokenDelimiter));
+ + const uint8_t* additional_data_bits =
+ + reinterpret_cast<const uint8_t*>(remaining_args.c_str());
+-+ additional_data = std::vector<const uint8_t>(
+++ additional_data = std::vector<uint8_t>(
+ + additional_data_bits, additional_data_bits + additional_data_size);
+ + }
+ +
+@@ -189,7 +189,7 @@ index 0ea5eb3e3cf055d981ab73486115bac53287f2d7..fe68beb4b2522d27e07dbbb3341f100f
+ base::CommandLine* parsed_command_line,
+ - base::FilePath* current_directory) {
+ + base::FilePath* current_directory,
+-+ std::vector<const uint8_t>* parsed_additional_data) {
+++ std::vector<uint8_t>* parsed_additional_data) {
+ // We should have enough room for the shortest command (min_message_size)
+ // and also be a multiple of wchar_t bytes. The shortest command
+ - // possible is L"START\0\0" (empty current directory and command line).
+@@ -230,7 +230,7 @@ index 0ea5eb3e3cf055d981ab73486115bac53287f2d7..fe68beb4b2522d27e07dbbb3341f100f
+ + msg.substr(fourth_null + 1, fifth_null - fourth_null);
+ + const uint8_t* additional_data_bytes =
+ + reinterpret_cast<const uint8_t*>(additional_data.c_str());
+-+ *parsed_additional_data = std::vector<const uint8_t>(additional_data_bytes,
+++ *parsed_additional_data = std::vector<uint8_t>(additional_data_bytes,
+ + additional_data_bytes + additional_data_length);
+ +
+ return true;
+@@ -241,7 +241,7 @@ index 0ea5eb3e3cf055d981ab73486115bac53287f2d7..fe68beb4b2522d27e07dbbb3341f100f
+ base::CommandLine parsed_command_line(base::CommandLine::NO_PROGRAM);
+ base::FilePath current_directory;
+ - if (!ParseCommandLine(cds, &parsed_command_line, &current_directory)) {
+-+ std::vector<const uint8_t> additional_data;
+++ std::vector<uint8_t> additional_data;
+ + if (!ParseCommandLine(cds, &parsed_command_line, &current_directory, &additional_data)) {
+ *result = TRUE;
+ return true;
+--- a/shell/browser/api/electron_api_app.cc
++++ b/shell/browser/api/electron_api_app.cc
+@@ -519,10 +519,10 @@ bool NotificationCallbackWrapper(
+ const base::RepeatingCallback<
+ void(const base::CommandLine& command_line,
+ const base::FilePath& current_directory,
+- const std::vector<const uint8_t> additional_data)>& callback,
++ const std::vector<uint8_t> additional_data)>& callback,
+ const base::CommandLine& cmd,
+ const base::FilePath& cwd,
+- const std::vector<const uint8_t> additional_data) {
++ const std::vector<uint8_t> additional_data) {
+ // Make sure the callback is called after app gets ready.
+ if (Browser::Get()->is_ready()) {
+ callback.Run(cmd, cwd, std::move(additional_data));
+@@ -1083,7 +1083,7 @@ std::string App::GetLocaleCountryCode() {
+
+ void App::OnSecondInstance(const base::CommandLine& cmd,
+ const base::FilePath& cwd,
+- const std::vector<const uint8_t> additional_data) {
++ const std::vector<uint8_t> additional_data) {
+ v8::Isolate* isolate = JavascriptEnvironment::GetIsolate();
+ v8::Locker locker(isolate);
+ v8::HandleScope handle_scope(isolate);
+--- a/shell/browser/api/electron_api_app.h
++++ b/shell/browser/api/electron_api_app.h
+@@ -195,7 +195,7 @@ class App : public ElectronBrowserClient::Delegate,
+ std::string GetLocaleCountryCode();
+ void OnSecondInstance(const base::CommandLine& cmd,
+ const base::FilePath& cwd,
+- const std::vector<const uint8_t> additional_data);
++ const std::vector<uint8_t> additional_data);
+ bool HasSingleInstanceLock() const;
+ bool RequestSingleInstanceLock(gin::Arguments* args);
+ void ReleaseSingleInstanceLock();
diff --git a/use-system-libraries-in-node.patch b/use-system-libraries-in-node.patch
new file mode 100644
index 000000000000..1dbffc204e85
--- /dev/null
+++ b/use-system-libraries-in-node.patch
@@ -0,0 +1,53 @@
+--- a/third_party/electron_node/BUILD.gn
++++ b/third_party/electron_node/BUILD.gn
+@@ -42,6 +42,18 @@
+ node_module_version = ""
+ }
+
++if (is_linux) {
++ import("//build/config/linux/pkg_config.gni")
++
++ pkg_config("cares") {
++ packages = [ "libcares" ]
++ }
++
++ pkg_config("nghttp2") {
++ packages = [ "libnghttp2" ]
++ }
++}
++
+ assert(!node_use_dtrace, "node_use_dtrace not supported in GN")
+ assert(!node_use_etw, "node_use_etw not supported in GN")
+
+@@ -182,11 +194,9 @@
+ component("node_lib") {
+ deps = [
+ ":node_js2c",
+- "deps/cares",
+ "deps/histogram",
+ "deps/googletest:gtest",
+ "deps/llhttp",
+- "deps/nghttp2",
+ "deps/uvwasi",
+ "//third_party/zlib",
+ "//third_party/brotli:dec",
+@@ -202,6 +212,19 @@
+ public_configs = [ ":node_lib_config" ]
+ include_dirs = [ "src" ]
+ libs = []
++ if (is_linux) {
++ configs += [
++ ":cares",
++ ":nghttp2",
++ ]
++ libs += [ "http_parser" ]
++ } else {
++ deps += [
++ "deps/cares",
++ "deps/http_parser",
++ "deps/nghttp2",
++ ]
++ }
+ frameworks = []
+ cflags_cc = [
+ "-Wno-deprecated-declarations",